﻿package com.robotacid.engine {
	import com.robotacid.geom.Dot;
	import com.robotacid.geom.Pixel;
	import com.robotacid.phys.Particle;
	import com.robotacid.phys.Spring;
	import flash.display.BitmapData;
	
	/**
	 * ...
	 * @author steed
	 */
	public class Car extends Spring{
		
		public var ground:BitmapData;
		
		public static const DIR:Array = [new Pixel(0, -1), new Pixel(0, 1), new Pixel(1, 0), new Pixel( -1, 0)];
		
		public function Car(a:Particle, b:Particle, ground:BitmapData) {
			super(a, b);
			this.ground = ground;
		}
		
		public function main():void{
			// verlet
			(a as Particle).verlet(0, 1, 0.99);
			(b as Particle).verlet(0, 1, 0.99);
			// update spring
			updateSpring();
			// resolve
			var n:int;
			n = ground.getPixel32(a.x >> 0, a.y >> 0) & 0xFF000000;
			if(n != 0){
				resolveWheel(a);
			}
			n = ground.getPixel32(b.x >> 0, b.y >> 0) & 0xFF000000;
			if(n != 0){
				resolveWheel(b);
			}
			
		}
		
		public function resolveWheel(w:Dot):void{
			var i:int, j:int, choice:int = -1, dist:int = ground.width, n:int;
			for(i = 0; i < DIR.length; i++){
				var test:Pixel = new Pixel(w.x, w.y);
				for(j = 0; j < dist; j++){
					test.x += DIR[i].x;
					test.y += DIR[i].y;
					n = ground.getPixel32(test.x, test.y) & 0xFF000000;
					if(n == 0 && j < dist){
						choice = i;
						dist = j;
						break;
					}
				}
			}
				w.x += DIR[choice].x * dist;
				w.y += DIR[choice].y * dist;
		}
	}
	
}