﻿package com.robotacid.geom {
	import flash.display.Graphics;
	
	/**
	* Line class for vector math and calculation of positions and directions
	*
	* @author Aaron Steed
	*/
	public class Line {
		
		public var a:Dot;// 		Old position x,y
		public var b:Dot;// 		Current position x,y
		public var vx:Number;// 	distance between p0.x and p1.x
		public var vy:Number;// 	distance between p0.y and p1.y
		public var length:Number;// vector length (pythagoras length of a to b)
		public var sq_length:Number;// squared length
		public var dx:Number;// 	x value of unit vector (equal to Math.cos(theta))
		public var dy:Number;// 	y value of unit vector (equal to Math.sin(theta))
		public var rx:Number;// 	x value of right hand unit vector
		public var ry:Number;// 	y value of right hand unit vector
		public var lx:Number;// 	x value of left hand unit vector
		public var ly:Number;// 	y value of left hand unit vector
		public var theta:Number;// 	rotation - updated by calling atan2 or rotate methods
		
		public function Line(a:Dot, b:Dot){
			this.a = a;
			this.b = b;
			updateLine();
		}
		/* Call this whenever the position of a or b is updated to recalculate properties */
		public function updateLine():void{
			vx = b.x - a.x;
			vy = b.y - a.y;
			// length of vector
			sq_length = vx * vx + vy * vy;
			length = Math.sqrt(sq_length);
			// normalized unit-sized components
			if (length > 0) {
				dx = vx / length;
				dy = vy / length;
			} else {
				dx = dy = 0;
			}
			// right hand normal
			rx = -dy;
			ry = dx;
			// left hand normal
			lx = dy;
			ly = -dx;
		}
		/* draw this line */
		public function draw(gfx:Graphics):void{
			gfx.moveTo(a.x, a.y);
			gfx.lineTo(b.x, b.y);
		}
		
	}
	
}