﻿package com.robotacid.phys {
	import com.robotacid.geom.Dot;
	import com.robotacid.geom.Line;
	
	/**
	* Free floating Verlet Integration particle
	*
	* This is more a reference than something I use these days
	* it's far more efficient to inline verlet integration
	*
	* Useful for doing basic springs though
	*
	* To manage a physics system with springs, call methods in the following order:
	*
	* verlet, then update springs, then pin static particles, then constrain any springs
	*
	* @author Aaron Steed, robotacid.com
	*/
	public class Particle extends Dot{
		public var ix:Number;//		initial x position
		public var iy:Number;//		initial y position
		public var px:Number;//		previous x position
		public var py:Number;//		previous y position
		public var temp_x:Number;//		temp variable
		public var temp_y:Number;//		temp variable
		
		public function Particle(x:Number = 0, y:Number = 0){
			super(x, y);
			px = temp_x = x;
			py = temp_y = y;
		}
		/* Moves the particle */
		public function verlet(gravity_x:Number, gravity_y:Number, damping:Number):void{
			temp_x = x;
			temp_y = y;
			x += damping * (x - px) + gravity_x;
			y += damping * (y - py) + gravity_y;
			px = temp_x;
			py = temp_y;
		}
		
		
	}
	
}